/* window.c generated by valac 0.56.18, the Vala compiler
 * generated from window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014, 2020 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include "libsudoku.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>

#define SUDOKU_WINDOW_small_window_width 600
#define SUDOKU_WINDOW_smallest_possible_width 360
#define SUDOKU_WINDOW_margin_default_size 25
#define SUDOKU_WINDOW_margin_small_size 10
#define SUDOKU_WINDOW_margin_size_diff (SUDOKU_WINDOW_margin_default_size - SUDOKU_WINDOW_margin_small_size)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_WINDOW (sudoku_window_get_type ())
#define SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_WINDOW, SudokuWindow))
#define SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_WINDOW, SudokuWindowClass))
#define IS_SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_WINDOW))
#define IS_SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_WINDOW))
#define SUDOKU_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_WINDOW, SudokuWindowClass))

typedef struct _SudokuWindow SudokuWindow;
typedef struct _SudokuWindowClass SudokuWindowClass;
typedef struct _SudokuWindowPrivate SudokuWindowPrivate;

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef enum  {
	SUDOKU_WINDOW_SCREEN_NONE,
	SUDOKU_WINDOW_SCREEN_PLAY,
	SUDOKU_WINDOW_SCREEN_CREATE,
	SUDOKU_WINDOW_SCREEN_MENU
} SudokuWindowScreen;

#define TYPE_SUDOKU_WINDOW_SCREEN (sudoku_window_screen_get_type ())
enum  {
	SUDOKU_WINDOW_0_PROPERTY,
	SUDOKU_WINDOW_SETTINGS_PROPERTY,
	SUDOKU_WINDOW_VIEW_PROPERTY,
	SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY,
	SUDOKU_WINDOW_SHOW_TIMER_PROPERTY,
	SUDOKU_WINDOW_NUM_PROPERTIES
};
static GParamSpec* sudoku_window_properties[SUDOKU_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuWindow {
	AdwApplicationWindow parent_instance;
	SudokuWindowPrivate * priv;
};

struct _SudokuWindowClass {
	AdwApplicationWindowClass parent_class;
};

struct _SudokuWindowPrivate {
	AdwWindowTitle* windowtitle;
	AdwHeaderBar* headerbar;
	GtkBox* game_box;
	GtkBox* start_box;
	GtkButton* start_button;
	GtkCheckButton* custom_check;
	GtkCheckButton* easy_check;
	GtkCheckButton* medium_check;
	GtkCheckButton* hard_check;
	GtkCheckButton* very_hard_check;
	GtkMenuButton* main_menu;
	GtkToggleButton* earmark_mode_button;
	GtkButton* undo_button;
	GtkButton* redo_button;
	GtkButton* back_button;
	GtkButton* unfullscreen_button;
	GtkButton* play_custom_game_button;
	GtkButton* play_pause_button;
	GtkButton* toggle_fullscreen_button;
	GtkBox* clock_box;
	GtkLabel* clock_label;
	gboolean window_is_maximized;
	gboolean window_is_fullscreen;
	gint window_width;
	gint window_height;
	gint small_window_height;
	gint smallest_possible_height;
	gboolean window_width_is_small;
	gboolean window_height_is_small;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureClick* backwards_controller;
	GtkGestureClick* forwards_controller;
	GtkEventControllerScroll* scroll_controller;
	GSettings* _settings;
	SudokuView* _view;
	SudokuWindowScreen _current_screen;
	gboolean _show_timer;
};

static gint SudokuWindow_private_offset;
static gpointer sudoku_window_parent_class = NULL;

VALA_EXTERN GType sudoku_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuWindow, g_object_unref)
VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_window_screen_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SudokuWindow* sudoku_window_new (GSettings* settings);
VALA_EXTERN SudokuWindow* sudoku_window_construct (GType object_type,
                                       GSettings* settings);
static void sudoku_window_set_settings (SudokuWindow* self,
                                 GSettings* value);
static void sudoku_window_construct_window_parameters (SudokuWindow* self);
static void __lambda6_ (SudokuWindow* self);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda7_ (SudokuWindow* self);
static void ___lambda7__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda8_ (SudokuWindow* self);
VALA_EXTERN SudokuView* sudoku_window_get_view (SudokuWindow* self);
VALA_EXTERN void sudoku_view_set_has_selection (SudokuView* self,
                                    gboolean value);
static void ___lambda8__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void sudoku_window_set_gamebox_width_margins (SudokuWindow* self,
                                              gint width);
static void sudoku_window_set_gamebox_height_margins (SudokuWindow* self,
                                               gint height);
static void sudoku_window_button_released_cb (SudokuWindow* self,
                                       GtkGestureClick* gesture,
                                       gint n_press,
                                       gdouble x,
                                       gdouble y);
static void _sudoku_window_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                   gint n_press,
                                                                   gdouble x,
                                                                   gdouble y,
                                                                   gpointer self);
static void sudoku_window_backwards_pressed_cb (SudokuWindow* self,
                                         GtkGestureClick* gesture,
                                         gint n_press,
                                         gdouble x,
                                         gdouble y);
static void _sudoku_window_backwards_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                    gint n_press,
                                                                    gdouble x,
                                                                    gdouble y,
                                                                    gpointer self);
static void sudoku_window_forwards_pressed_cb (SudokuWindow* self,
                                        GtkGestureClick* gesture,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y);
static void _sudoku_window_forwards_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                   gint n_press,
                                                                   gdouble x,
                                                                   gdouble y,
                                                                   gpointer self);
static gboolean sudoku_window_scroll_cb (SudokuWindow* self,
                                  GtkEventControllerScroll* event,
                                  gdouble dx,
                                  gdouble dy);
static gboolean _sudoku_window_scroll_cb_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                      gdouble dx,
                                                                      gdouble dy,
                                                                      gpointer self);
static void sudoku_window_scroll_begin_cb (SudokuWindow* self,
                                    GtkEventControllerScroll* event);
static void _sudoku_window_scroll_begin_cb_gtk_event_controller_scroll_scroll_begin (GtkEventControllerScroll* _sender,
                                                                              gpointer self);
static void sudoku_window_scroll_end_cb (SudokuWindow* self,
                                  GtkEventControllerScroll* event);
static void _sudoku_window_scroll_end_cb_gtk_event_controller_scroll_scroll_end (GtkEventControllerScroll* _sender,
                                                                          gpointer self);
static gboolean sudoku_window_close_cb (SudokuWindow* self);
static gboolean _sudoku_window_close_cb_gtk_window_close_request (GtkWindow* _sender,
                                                           gpointer self);
VALA_EXTERN GSettings* sudoku_window_get_settings (SudokuWindow* self);
VALA_EXTERN void sudoku_window_set_show_timer (SudokuWindow* self,
                                   gboolean value);
static void sudoku_window_start_game_cb (SudokuWindow* self,
                                  GtkButton* btn);
static gboolean* _bool_dup (gboolean* self);
static void _sudoku_window_start_game_cb_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
static void sudoku_window_window_width_is_big_cb (SudokuWindow* self);
VALA_EXTERN SudokuWindowScreen sudoku_window_get_current_screen (SudokuWindow* self);
VALA_EXTERN gboolean sudoku_window_get_show_timer (SudokuWindow* self);
static void sudoku_window_window_width_is_small_cb (SudokuWindow* self);
VALA_EXTERN void sudoku_window_will_start_game (SudokuWindow* self);
VALA_EXTERN void sudoku_window_start_game (SudokuWindow* self,
                               SudokuGame* game);
static void sudoku_window_tick_cb (SudokuWindow* self);
static void _sudoku_window_tick_cb_sudoku_game_tick (SudokuGame* _sender,
                                              gpointer self);
VALA_EXTERN void sudoku_window_show_game_view (SudokuWindow* self);
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game,
                             GSettings* settings);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game,
                                   GSettings* settings);
static void sudoku_window_set_view (SudokuWindow* self,
                             SudokuView* value);
VALA_EXTERN void sudoku_window_show_menu_screen (SudokuWindow* self);
static void sudoku_window_set_current_screen (SudokuWindow* self,
                                       SudokuWindowScreen value);
VALA_EXTERN void sudoku_window_set_board_visible (SudokuWindow* self,
                                      gboolean visible);
VALA_EXTERN void sudoku_window_activate_difficulty_checkbutton (SudokuWindow* self,
                                                    DifficultyCategory difficulty);
VALA_EXTERN gboolean sudoku_window_is_board_visible (SudokuWindow* self);
VALA_EXTERN void sudoku_window_display_pause_button (SudokuWindow* self);
VALA_EXTERN void sudoku_window_board_completed (SudokuWindow* self);
VALA_EXTERN void sudoku_view_dismiss_picker (SudokuView* self);
static gdouble sudoku_window_normalize (SudokuWindow* self,
                                 gint val,
                                 gint min,
                                 gint max);
static void sudoku_window_real_size_allocate (GtkWidget* base,
                                       gint width,
                                       gint height,
                                       gint baseline);
static void sudoku_window_real_dispose (GObject* base);
static void sudoku_window_finalize (GObject * obj);
static GType sudoku_window_get_type_once (void);
static void _vala_sudoku_window_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_sudoku_window_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
sudoku_window_get_instance_private (SudokuWindow* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuWindow_private_offset);
}

static void
__lambda6_ (SudokuWindow* self)
{
	self->priv->window_is_maximized = !self->priv->window_is_maximized;
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda6_ ((SudokuWindow*) self);
}

static void
__lambda7_ (SudokuWindow* self)
{
	self->priv->window_is_fullscreen = !self->priv->window_is_fullscreen;
	if (self->priv->window_is_fullscreen) {
		AdwHeaderBar* _tmp0_;
		GtkButton* _tmp1_;
		GtkButton* _tmp2_;
		GtkButton* _tmp3_;
		_tmp0_ = self->priv->headerbar;
		adw_header_bar_set_decoration_layout (_tmp0_, ":close");
		_tmp1_ = self->priv->toggle_fullscreen_button;
		gtk_button_set_icon_name (_tmp1_, "view-restore-symbolic");
		_tmp2_ = self->priv->toggle_fullscreen_button;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp2_, _ ("Leave Fullscreen"));
		_tmp3_ = self->priv->unfullscreen_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp3_, TRUE);
	} else {
		AdwHeaderBar* _tmp4_;
		GtkButton* _tmp5_;
		GtkButton* _tmp6_;
		GtkButton* _tmp7_;
		_tmp4_ = self->priv->headerbar;
		adw_header_bar_set_decoration_layout (_tmp4_, NULL);
		_tmp5_ = self->priv->toggle_fullscreen_button;
		gtk_button_set_icon_name (_tmp5_, "view-fullscreen-symbolic");
		_tmp6_ = self->priv->toggle_fullscreen_button;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, _ ("Fullscreen"));
		_tmp7_ = self->priv->unfullscreen_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
		if (self->priv->window_is_maximized) {
			gtk_window_maximize ((GtkWindow*) self);
			return;
		}
	}
}

static void
___lambda7__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda7_ ((SudokuWindow*) self);
}

static void
__lambda8_ (SudokuWindow* self)
{
	SudokuView* _tmp0_;
	_tmp0_ = self->priv->_view;
	if (_tmp0_ != NULL) {
		SudokuView* _tmp1_;
		GtkMenuButton* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp1_ = self->priv->_view;
		_tmp2_ = self->priv->main_menu;
		_tmp3_ = gtk_menu_button_get_active (_tmp2_);
		_tmp4_ = _tmp3_;
		sudoku_view_set_has_selection (_tmp1_, !_tmp4_);
	}
}

static void
___lambda8__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda8_ ((SudokuWindow*) self);
}

static void
_sudoku_window_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                              gint n_press,
                                                              gdouble x,
                                                              gdouble y,
                                                              gpointer self)
{
	sudoku_window_button_released_cb ((SudokuWindow*) self, _sender, n_press, x, y);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_sudoku_window_backwards_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                               gint n_press,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self)
{
	sudoku_window_backwards_pressed_cb ((SudokuWindow*) self, _sender, n_press, x, y);
}

static void
_sudoku_window_forwards_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                              gint n_press,
                                                              gdouble x,
                                                              gdouble y,
                                                              gpointer self)
{
	sudoku_window_forwards_pressed_cb ((SudokuWindow*) self, _sender, n_press, x, y);
}

static gboolean
_sudoku_window_scroll_cb_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                             gdouble dx,
                                                             gdouble dy,
                                                             gpointer self)
{
	gboolean result;
	result = sudoku_window_scroll_cb ((SudokuWindow*) self, _sender, dx, dy);
	return result;
}

static void
_sudoku_window_scroll_begin_cb_gtk_event_controller_scroll_scroll_begin (GtkEventControllerScroll* _sender,
                                                                         gpointer self)
{
	sudoku_window_scroll_begin_cb ((SudokuWindow*) self, _sender);
}

static void
_sudoku_window_scroll_end_cb_gtk_event_controller_scroll_scroll_end (GtkEventControllerScroll* _sender,
                                                                     gpointer self)
{
	sudoku_window_scroll_end_cb ((SudokuWindow*) self, _sender);
}

static gboolean
_sudoku_window_close_cb_gtk_window_close_request (GtkWindow* _sender,
                                                  gpointer self)
{
	gboolean result;
	result = sudoku_window_close_cb ((SudokuWindow*) self);
	return result;
}

SudokuWindow*
sudoku_window_construct (GType object_type,
                         GSettings* settings)
{
	SudokuWindow * self = NULL;
	GtkMenuButton* _tmp0_;
	GtkGestureClick* _tmp1_;
	GtkGestureClick* _tmp2_;
	GtkGestureClick* _tmp3_;
	GtkGestureClick* _tmp4_;
	GtkEventController* _tmp5_;
	GtkGestureClick* _tmp6_;
	GtkGestureClick* _tmp7_;
	GtkGestureClick* _tmp8_;
	GtkGestureClick* _tmp9_;
	GtkGestureClick* _tmp10_;
	GtkEventController* _tmp11_;
	GtkGestureClick* _tmp12_;
	GtkGestureClick* _tmp13_;
	GtkGestureClick* _tmp14_;
	GtkGestureClick* _tmp15_;
	GtkGestureClick* _tmp16_;
	GtkEventController* _tmp17_;
	GtkEventControllerScroll* _tmp18_;
	GtkEventControllerScroll* _tmp19_;
	GtkEventControllerScroll* _tmp20_;
	GtkEventControllerScroll* _tmp21_;
	GtkEventControllerScroll* _tmp22_;
	GtkEventControllerScroll* _tmp23_;
	GtkEventController* _tmp24_;
	g_return_val_if_fail (settings != NULL, NULL);
	self = (SudokuWindow*) g_object_new (object_type, NULL);
	sudoku_window_set_settings (self, settings);
	sudoku_window_construct_window_parameters (self);
	g_signal_connect_object ((GObject*) self, "notify::maximized", (GCallback) ___lambda6__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::fullscreened", (GCallback) ___lambda7__g_object_notify, self, 0);
	_tmp0_ = self->priv->main_menu;
	g_signal_connect_object ((GObject*) _tmp0_, "notify::active", (GCallback) ___lambda8__g_object_notify, self, 0);
	if (self->priv->window_is_fullscreen) {
		gtk_window_fullscreen ((GtkWindow*) self);
	} else {
		if (self->priv->window_is_maximized) {
			gtk_window_maximize ((GtkWindow*) self);
		} else {
			sudoku_window_set_gamebox_width_margins (self, self->priv->window_width);
			sudoku_window_set_gamebox_height_margins (self, self->priv->window_height);
		}
	}
	_tmp1_ = (GtkGestureClick*) gtk_gesture_click_new ();
	_g_object_unref0 (self->priv->button_controller);
	self->priv->button_controller = _tmp1_;
	_tmp2_ = self->priv->button_controller;
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp2_, (guint) 0);
	_tmp3_ = self->priv->button_controller;
	g_signal_connect_object (_tmp3_, "released", (GCallback) _sudoku_window_button_released_cb_gtk_gesture_click_released, self, 0);
	_tmp4_ = self->priv->button_controller;
	_tmp5_ = _g_object_ref0 ((GtkEventController*) _tmp4_);
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp5_);
	_tmp6_ = (GtkGestureClick*) gtk_gesture_click_new ();
	_g_object_unref0 (self->priv->backwards_controller);
	self->priv->backwards_controller = _tmp6_;
	_tmp7_ = self->priv->backwards_controller;
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp7_, (guint) 8);
	_tmp8_ = self->priv->backwards_controller;
	g_signal_connect_object (_tmp8_, "pressed", (GCallback) _sudoku_window_backwards_pressed_cb_gtk_gesture_click_pressed, self, 0);
	_tmp9_ = self->priv->backwards_controller;
	gtk_event_controller_set_propagation_limit ((GtkEventController*) _tmp9_, GTK_LIMIT_NONE);
	_tmp10_ = self->priv->backwards_controller;
	_tmp11_ = _g_object_ref0 ((GtkEventController*) _tmp10_);
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp11_);
	_tmp12_ = (GtkGestureClick*) gtk_gesture_click_new ();
	_g_object_unref0 (self->priv->forwards_controller);
	self->priv->forwards_controller = _tmp12_;
	_tmp13_ = self->priv->forwards_controller;
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp13_, (guint) 9);
	_tmp14_ = self->priv->forwards_controller;
	g_signal_connect_object (_tmp14_, "pressed", (GCallback) _sudoku_window_forwards_pressed_cb_gtk_gesture_click_pressed, self, 0);
	_tmp15_ = self->priv->forwards_controller;
	gtk_event_controller_set_propagation_limit ((GtkEventController*) _tmp15_, GTK_LIMIT_NONE);
	_tmp16_ = self->priv->forwards_controller;
	_tmp17_ = _g_object_ref0 ((GtkEventController*) _tmp16_);
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp17_);
	_tmp18_ = (GtkEventControllerScroll*) gtk_event_controller_scroll_new (GTK_EVENT_CONTROLLER_SCROLL_VERTICAL);
	_g_object_unref0 (self->priv->scroll_controller);
	self->priv->scroll_controller = _tmp18_;
	_tmp19_ = self->priv->scroll_controller;
	g_signal_connect_object (_tmp19_, "scroll", (GCallback) _sudoku_window_scroll_cb_gtk_event_controller_scroll_scroll, self, 0);
	_tmp20_ = self->priv->scroll_controller;
	g_signal_connect_object (_tmp20_, "scroll-begin", (GCallback) _sudoku_window_scroll_begin_cb_gtk_event_controller_scroll_scroll_begin, self, 0);
	_tmp21_ = self->priv->scroll_controller;
	g_signal_connect_object (_tmp21_, "scroll-end", (GCallback) _sudoku_window_scroll_end_cb_gtk_event_controller_scroll_scroll_end, self, 0);
	_tmp22_ = self->priv->scroll_controller;
	gtk_event_controller_set_propagation_limit ((GtkEventController*) _tmp22_, GTK_LIMIT_NONE);
	_tmp23_ = self->priv->scroll_controller;
	_tmp24_ = _g_object_ref0 ((GtkEventController*) _tmp23_);
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp24_);
	g_signal_connect_object ((GtkWindow*) self, "close-request", (GCallback) _sudoku_window_close_cb_gtk_window_close_request, self, 0);
	return self;
}

SudokuWindow*
sudoku_window_new (GSettings* settings)
{
	return sudoku_window_construct (TYPE_SUDOKU_WINDOW, settings);
}

static void
sudoku_window_construct_window_parameters (SudokuWindow* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	gint headerbar_natural_height = 0;
	AdwHeaderBar* _tmp5_;
	gint _tmp6_ = 0;
	GtkLabel* title_label = NULL;
	AdwWindowTitle* _tmp7_;
	GtkWidget* _tmp8_;
	GtkWidget* _tmp9_;
	GtkLabel* _tmp10_;
	GValue _tmp11_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_settings;
	self->priv->window_width = g_settings_get_int (_tmp0_, "window-width");
	_tmp1_ = self->priv->_settings;
	self->priv->window_height = g_settings_get_int (_tmp1_, "window-height");
	_tmp2_ = self->priv->_settings;
	self->priv->window_is_maximized = g_settings_get_boolean (_tmp2_, "window-is-maximized");
	_tmp3_ = self->priv->_settings;
	self->priv->window_is_fullscreen = g_settings_get_boolean (_tmp3_, "window-is-fullscreen");
	_tmp4_ = self->priv->_settings;
	sudoku_window_set_show_timer (self, g_settings_get_boolean (_tmp4_, "show-timer"));
	_tmp5_ = self->priv->headerbar;
	gtk_widget_measure ((GtkWidget*) _tmp5_, GTK_ORIENTATION_VERTICAL, -1, NULL, &_tmp6_, NULL, NULL);
	headerbar_natural_height = _tmp6_;
	self->priv->small_window_height = SUDOKU_WINDOW_small_window_width + headerbar_natural_height;
	self->priv->smallest_possible_height = SUDOKU_WINDOW_smallest_possible_width + headerbar_natural_height;
	self->priv->window_width_is_small = self->priv->window_width <= SUDOKU_WINDOW_small_window_width;
	self->priv->window_height_is_small = self->priv->window_height <= self->priv->small_window_height;
	gtk_widget_set_size_request ((GtkWidget*) self, SUDOKU_WINDOW_smallest_possible_width, self->priv->smallest_possible_height);
	gtk_window_set_default_size ((GtkWindow*) self, self->priv->window_width, self->priv->window_height);
	_tmp7_ = self->priv->windowtitle;
	_tmp8_ = gtk_widget_get_first_child ((GtkWidget*) _tmp7_);
	_tmp9_ = gtk_widget_get_first_child (_tmp8_);
	_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_label_get_type (), GtkLabel));
	title_label = _tmp10_;
	g_value_init (&_tmp11_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp11_, FALSE);
	g_object_set_property ((GObject*) title_label, "ellipsize", &_tmp11_);
	G_IS_VALUE (&_tmp11_) ? (g_value_unset (&_tmp11_), NULL) : NULL;
	_g_object_unref0 (title_label);
}

static gboolean
sudoku_window_close_cb (SudokuWindow* self)
{
	GSettings* _tmp0_;
	gint default_width = 0;
	gint default_height = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_settings;
	g_settings_delay (_tmp0_);
	gtk_window_get_default_size ((GtkWindow*) self, &_tmp1_, &_tmp2_);
	default_width = _tmp1_;
	default_height = _tmp2_;
	_tmp3_ = self->priv->_settings;
	g_settings_set_int (_tmp3_, "window-width", default_width);
	_tmp4_ = self->priv->_settings;
	g_settings_set_int (_tmp4_, "window-height", default_height);
	_tmp5_ = self->priv->_settings;
	g_settings_set_boolean (_tmp5_, "window-is-maximized", self->priv->window_is_maximized);
	_tmp6_ = self->priv->_settings;
	g_settings_set_boolean (_tmp6_, "window-is-fullscreen", self->priv->window_is_fullscreen);
	_tmp7_ = self->priv->_settings;
	g_settings_apply (_tmp7_);
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
	dup = g_new0 (gboolean, 1);
	memcpy (dup, self, sizeof (gboolean));
	return dup;
}

static gpointer
__bool_dup0 (gpointer self)
{
	return self ? _bool_dup (self) : NULL;
}

static void
sudoku_window_start_game_cb (SudokuWindow* self,
                             GtkButton* btn)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (btn != NULL);
	_tmp0_ = self->priv->easy_check;
	_tmp1_ = gtk_check_button_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkWidget* _tmp3_ = NULL;
		gboolean* _tmp4_ = NULL;
		_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
		_tmp4_ = NULL;
		if (_tmp3_ != NULL) {
			gboolean _tmp5_;
			gboolean* _tmp6_;
			_tmp5_ = gtk_widget_activate_action (_tmp3_, "app.start-game", "i", 1, NULL);
			_tmp6_ = __bool_dup0 (&_tmp5_);
			_g_free0 (_tmp4_);
			_tmp4_ = _tmp6_;
		}
		_g_free0 (_tmp4_);
	} else {
		GtkCheckButton* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		_tmp7_ = self->priv->medium_check;
		_tmp8_ = gtk_check_button_get_active (_tmp7_);
		_tmp9_ = _tmp8_;
		if (_tmp9_) {
			GtkWidget* _tmp10_ = NULL;
			gboolean* _tmp11_ = NULL;
			_tmp10_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
			_tmp11_ = NULL;
			if (_tmp10_ != NULL) {
				gboolean _tmp12_;
				gboolean* _tmp13_;
				_tmp12_ = gtk_widget_activate_action (_tmp10_, "app.start-game", "i", 2, NULL);
				_tmp13_ = __bool_dup0 (&_tmp12_);
				_g_free0 (_tmp11_);
				_tmp11_ = _tmp13_;
			}
			_g_free0 (_tmp11_);
		} else {
			GtkCheckButton* _tmp14_;
			gboolean _tmp15_;
			gboolean _tmp16_;
			_tmp14_ = self->priv->hard_check;
			_tmp15_ = gtk_check_button_get_active (_tmp14_);
			_tmp16_ = _tmp15_;
			if (_tmp16_) {
				GtkWidget* _tmp17_ = NULL;
				gboolean* _tmp18_ = NULL;
				_tmp17_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
				_tmp18_ = NULL;
				if (_tmp17_ != NULL) {
					gboolean _tmp19_;
					gboolean* _tmp20_;
					_tmp19_ = gtk_widget_activate_action (_tmp17_, "app.start-game", "i", 3, NULL);
					_tmp20_ = __bool_dup0 (&_tmp19_);
					_g_free0 (_tmp18_);
					_tmp18_ = _tmp20_;
				}
				_g_free0 (_tmp18_);
			} else {
				GtkCheckButton* _tmp21_;
				gboolean _tmp22_;
				gboolean _tmp23_;
				_tmp21_ = self->priv->very_hard_check;
				_tmp22_ = gtk_check_button_get_active (_tmp21_);
				_tmp23_ = _tmp22_;
				if (_tmp23_) {
					GtkWidget* _tmp24_ = NULL;
					gboolean* _tmp25_ = NULL;
					_tmp24_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
					_tmp25_ = NULL;
					if (_tmp24_ != NULL) {
						gboolean _tmp26_;
						gboolean* _tmp27_;
						_tmp26_ = gtk_widget_activate_action (_tmp24_, "app.start-game", "i", 4, NULL);
						_tmp27_ = __bool_dup0 (&_tmp26_);
						_g_free0 (_tmp25_);
						_tmp25_ = _tmp27_;
					}
					_g_free0 (_tmp25_);
				} else {
					GtkCheckButton* _tmp28_;
					gboolean _tmp29_;
					gboolean _tmp30_;
					_tmp28_ = self->priv->custom_check;
					_tmp29_ = gtk_check_button_get_active (_tmp28_);
					_tmp30_ = _tmp29_;
					if (_tmp30_) {
						GtkWidget* _tmp31_ = NULL;
						gboolean* _tmp32_ = NULL;
						_tmp31_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
						_tmp32_ = NULL;
						if (_tmp31_ != NULL) {
							gboolean _tmp33_;
							gboolean* _tmp34_;
							_tmp33_ = gtk_widget_activate_action (_tmp31_, "app.start-game", "i", 5, NULL);
							_tmp34_ = __bool_dup0 (&_tmp33_);
							_g_free0 (_tmp32_);
							_tmp32_ = _tmp34_;
						}
						_g_free0 (_tmp32_);
					}
				}
			}
		}
	}
}

static void
_sudoku_window_start_game_cb_gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
	sudoku_window_start_game_cb ((SudokuWindow*) self, _sender);
}

static void
sudoku_window_window_width_is_big_cb (SudokuWindow* self)
{
	SudokuWindowScreen _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->window_width_is_small = FALSE;
	_tmp0_ = self->priv->_current_screen;
	if (_tmp0_ == SUDOKU_WINDOW_SCREEN_PLAY) {
		GtkBox* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
		GtkToggleButton* _tmp4_;
		_tmp1_ = self->priv->clock_box;
		_tmp2_ = sudoku_window_get_show_timer (self);
		_tmp3_ = _tmp2_;
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, _tmp3_);
		_tmp4_ = self->priv->earmark_mode_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, TRUE);
	}
}

static void
sudoku_window_window_width_is_small_cb (SudokuWindow* self)
{
	GtkBox* _tmp0_;
	SudokuWindowScreen _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->window_width_is_small = TRUE;
	_tmp0_ = self->priv->clock_box;
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
	_tmp1_ = self->priv->_current_screen;
	if (_tmp1_ == SUDOKU_WINDOW_SCREEN_PLAY) {
		GtkToggleButton* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp2_ = self->priv->earmark_mode_button;
		_tmp3_ = sudoku_window_get_show_timer (self);
		_tmp4_ = _tmp3_;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, !_tmp4_);
	}
}

void
sudoku_window_will_start_game (SudokuWindow* self)
{
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->back_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
}

static void
_sudoku_window_tick_cb_sudoku_game_tick (SudokuGame* _sender,
                                         gpointer self)
{
	sudoku_window_tick_cb ((SudokuWindow*) self);
}

void
sudoku_window_start_game (SudokuWindow* self,
                          SudokuGame* game)
{
	SudokuGame* _tmp0_;
	SudokuView* _tmp1_;
	GSettings* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
	GtkBox* _tmp7_;
	SudokuView* _tmp8_;
	SudokuView* _tmp9_;
	GtkButton* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (game != NULL);
	_tmp0_ = _g_object_ref0 (game);
	_g_object_unref0 (self->priv->game);
	self->priv->game = _tmp0_;
	g_signal_connect_object (game, "tick", (GCallback) _sudoku_window_tick_cb_sudoku_game_tick, self, 0);
	sudoku_game_start_clock (game);
	_tmp1_ = self->priv->_view;
	if (_tmp1_ != NULL) {
		GtkBox* _tmp2_;
		SudokuView* _tmp3_;
		_tmp2_ = self->priv->game_box;
		_tmp3_ = self->priv->_view;
		gtk_box_remove (_tmp2_, (GtkWidget*) _tmp3_);
	}
	sudoku_window_show_game_view (self);
	_tmp4_ = self->priv->_settings;
	_tmp5_ = sudoku_view_new (game, _tmp4_);
	g_object_ref_sink (_tmp5_);
	_tmp6_ = _tmp5_;
	sudoku_window_set_view (self, _tmp6_);
	_g_object_unref0 (_tmp6_);
	_tmp7_ = self->priv->game_box;
	_tmp8_ = self->priv->_view;
	gtk_box_prepend (_tmp7_, (GtkWidget*) _tmp8_);
	_tmp9_ = self->priv->_view;
	gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
	_tmp10_ = self->priv->back_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, TRUE);
}

void
sudoku_window_show_menu_screen (SudokuWindow* self)
{
	AdwWindowTitle* _tmp0_;
	GtkButton* _tmp1_;
	SudokuGame* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkBox* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	g_return_if_fail (self != NULL);
	sudoku_window_set_current_screen (self, SUDOKU_WINDOW_SCREEN_MENU);
	_tmp0_ = self->priv->windowtitle;
	adw_window_title_set_subtitle (_tmp0_, _ ("Select Difficulty"));
	sudoku_window_set_board_visible (self, FALSE);
	_tmp1_ = self->priv->back_button;
	_tmp2_ = self->priv->game;
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, _tmp2_ != NULL);
	_tmp3_ = self->priv->earmark_mode_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
	_tmp4_ = self->priv->undo_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
	_tmp5_ = self->priv->redo_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
	_tmp6_ = self->priv->clock_box;
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, FALSE);
	_tmp7_ = self->priv->play_pause_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
	_tmp8_ = self->priv->start_button;
	gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
}

void
sudoku_window_activate_difficulty_checkbutton (SudokuWindow* self,
                                               DifficultyCategory difficulty)
{
	g_return_if_fail (self != NULL);
	switch (difficulty) {
		case DIFFICULTY_CATEGORY_EASY:
		{
			GtkCheckButton* _tmp0_;
			_tmp0_ = self->priv->easy_check;
			g_signal_emit_by_name (_tmp0_, "activate");
			return;
		}
		case DIFFICULTY_CATEGORY_MEDIUM:
		{
			GtkCheckButton* _tmp1_;
			_tmp1_ = self->priv->medium_check;
			g_signal_emit_by_name (_tmp1_, "activate");
			return;
		}
		case DIFFICULTY_CATEGORY_HARD:
		{
			GtkCheckButton* _tmp2_;
			_tmp2_ = self->priv->hard_check;
			g_signal_emit_by_name (_tmp2_, "activate");
			return;
		}
		case DIFFICULTY_CATEGORY_VERY_HARD:
		{
			GtkCheckButton* _tmp3_;
			_tmp3_ = self->priv->very_hard_check;
			g_signal_emit_by_name (_tmp3_, "activate");
			return;
		}
		case DIFFICULTY_CATEGORY_CUSTOM:
		{
			GtkCheckButton* _tmp4_;
			_tmp4_ = self->priv->custom_check;
			g_signal_emit_by_name (_tmp4_, "activate");
			return;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

void
sudoku_window_set_board_visible (SudokuWindow* self,
                                 gboolean visible)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkButton* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->start_box;
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, !visible);
	_tmp1_ = self->priv->game_box;
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, visible);
	if (visible) {
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
		_tmp3_ = self->priv->game;
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp2_ = _tmp5_ == GAME_MODE_CREATE;
	} else {
		_tmp2_ = FALSE;
	}
	_tmp6_ = self->priv->play_custom_game_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, _tmp2_);
}

gboolean
sudoku_window_is_board_visible (SudokuWindow* self)
{
	GtkBox* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->game_box;
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
sudoku_window_show_game_view (SudokuWindow* self)
{
	SudokuGame* _tmp0_;
	SudokuGame* _tmp1_;
	GameMode _tmp2_;
	GameMode _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	SudokuGame* _tmp7_;
	GameMode _tmp8_;
	GameMode _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	_vala_return_if_fail (_tmp0_ != NULL, "game != null");
	_tmp1_ = self->priv->game;
	_tmp2_ = sudoku_game_get_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	sudoku_window_set_current_screen (self, (SudokuWindowScreen) _tmp3_);
	sudoku_window_set_board_visible (self, TRUE);
	_tmp4_ = self->priv->back_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
	_tmp5_ = self->priv->undo_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
	_tmp6_ = self->priv->redo_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
	_tmp7_ = self->priv->game;
	_tmp8_ = sudoku_game_get_mode (_tmp7_);
	_tmp9_ = _tmp8_;
	if (_tmp9_ == GAME_MODE_PLAY) {
		GtkButton* _tmp10_;
		gboolean _tmp11_ = FALSE;
		GtkToggleButton* _tmp14_;
		AdwWindowTitle* _tmp15_;
		SudokuGame* _tmp16_;
		SudokuBoard* _tmp17_;
		SudokuBoard* _tmp18_;
		DifficultyCategory _tmp19_;
		DifficultyCategory _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gboolean _tmp23_;
		gboolean _tmp24_;
		_tmp10_ = self->priv->play_custom_game_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
		if (!self->priv->window_width_is_small) {
			_tmp11_ = TRUE;
		} else {
			gboolean _tmp12_;
			gboolean _tmp13_;
			_tmp12_ = sudoku_window_get_show_timer (self);
			_tmp13_ = _tmp12_;
			_tmp11_ = !_tmp13_;
		}
		_tmp14_ = self->priv->earmark_mode_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp14_, _tmp11_);
		_tmp15_ = self->priv->windowtitle;
		_tmp16_ = self->priv->game;
		_tmp17_ = sudoku_game_get_board (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = sudoku_board_get_difficulty_category (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = difficulty_category_to_string (_tmp20_);
		_tmp22_ = _tmp21_;
		adw_window_title_set_subtitle (_tmp15_, _tmp22_);
		_g_free0 (_tmp22_);
		_tmp23_ = sudoku_window_get_show_timer (self);
		_tmp24_ = _tmp23_;
		if (_tmp24_) {
			GtkBox* _tmp25_;
			sudoku_window_display_pause_button (self);
			_tmp25_ = self->priv->clock_box;
			gtk_widget_set_visible ((GtkWidget*) _tmp25_, !self->priv->window_width_is_small);
		} else {
			GtkButton* _tmp26_;
			GtkBox* _tmp27_;
			_tmp26_ = self->priv->play_pause_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp26_, FALSE);
			_tmp27_ = self->priv->clock_box;
			gtk_widget_set_visible ((GtkWidget*) _tmp27_, FALSE);
		}
	} else {
		GtkToggleButton* _tmp28_;
		GtkBox* _tmp29_;
		GtkButton* _tmp30_;
		GtkButton* _tmp31_;
		AdwWindowTitle* _tmp32_;
		_tmp28_ = self->priv->earmark_mode_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp28_, FALSE);
		_tmp29_ = self->priv->clock_box;
		gtk_widget_set_visible ((GtkWidget*) _tmp29_, FALSE);
		_tmp30_ = self->priv->play_custom_game_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp30_, TRUE);
		_tmp31_ = self->priv->play_pause_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp31_, FALSE);
		_tmp32_ = self->priv->windowtitle;
		adw_window_title_set_subtitle (_tmp32_, _ ("Create Puzzle"));
	}
}

void
sudoku_window_board_completed (SudokuWindow* self)
{
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->play_custom_game_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
}

void
sudoku_window_display_pause_button (SudokuWindow* self)
{
	GtkButton* _tmp0_;
	const gchar* _tmp1_ = NULL;
	SudokuGame* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkButton* _tmp5_;
	const gchar* _tmp6_ = NULL;
	SudokuGame* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GtkButton* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->play_pause_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
	_tmp2_ = self->priv->game;
	_tmp3_ = sudoku_game_get_paused (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		_tmp1_ = "media-playback-start-symbolic";
	} else {
		_tmp1_ = "media-playback-pause-symbolic";
	}
	_tmp5_ = self->priv->play_pause_button;
	gtk_button_set_icon_name (_tmp5_, _tmp1_);
	_tmp7_ = self->priv->game;
	_tmp8_ = sudoku_game_get_paused (_tmp7_);
	_tmp9_ = _tmp8_;
	if (_tmp9_) {
		_tmp6_ = _ ("Play");
	} else {
		_tmp6_ = _ ("Pause");
	}
	_tmp10_ = self->priv->play_pause_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, _tmp6_);
}

static void
sudoku_window_tick_cb (SudokuWindow* self)
{
	gint elapsed_time = 0;
	SudokuGame* _tmp0_;
	gint hours = 0;
	gint minutes = 0;
	gint seconds = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	elapsed_time = (gint) sudoku_game_get_total_time_played (_tmp0_);
	hours = elapsed_time / 3600;
	minutes = (elapsed_time - (hours * 3600)) / 60;
	seconds = (elapsed_time - (hours * 3600)) - (minutes * 60);
	if (hours > 0) {
		GtkLabel* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = self->priv->clock_label;
		_tmp2_ = g_strdup_printf ("%02d∶\xE2\x80\x8E%02d∶\xE2\x80\x8E%02d", hours, minutes, seconds);
		_tmp3_ = _tmp2_;
		gtk_label_set_text (_tmp1_, _tmp3_);
		_g_free0 (_tmp3_);
	} else {
		GtkLabel* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = self->priv->clock_label;
		_tmp5_ = g_strdup_printf ("%02d∶\xE2\x80\x8E%02d", minutes, seconds);
		_tmp6_ = _tmp5_;
		gtk_label_set_text (_tmp4_, _tmp6_);
		_g_free0 (_tmp6_);
	}
}

static void
sudoku_window_button_released_cb (SudokuWindow* self,
                                  GtkGestureClick* gesture,
                                  gint n_press,
                                  gdouble x,
                                  gdouble y)
{
	gboolean _tmp0_ = FALSE;
	SudokuWindowScreen _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (gesture != NULL);
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->_current_screen;
	if (_tmp1_ != SUDOKU_WINDOW_SCREEN_MENU) {
		SudokuView* _tmp2_;
		_tmp2_ = self->priv->_view;
		sudoku_view_dismiss_picker (_tmp2_);
	}
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
}

static void
sudoku_window_backwards_pressed_cb (SudokuWindow* self,
                                    GtkGestureClick* gesture,
                                    gint n_press,
                                    gdouble x,
                                    gdouble y)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (gesture != NULL);
	gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.undo", NULL, NULL);
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
}

static void
sudoku_window_forwards_pressed_cb (SudokuWindow* self,
                                   GtkGestureClick* gesture,
                                   gint n_press,
                                   gdouble x,
                                   gdouble y)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (gesture != NULL);
	gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.redo", NULL, NULL);
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
}

static gboolean
sudoku_window_scroll_cb (SudokuWindow* self,
                         GtkEventControllerScroll* event,
                         gdouble dx,
                         gdouble dy)
{
	GdkModifierType state = 0U;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	state = gtk_event_controller_get_current_event_state ((GtkEventController*) event);
	if (state == GDK_CONTROL_MASK) {
		if (dy <= ((gdouble) -1)) {
			gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.zoom-in", NULL, NULL);
			result = GDK_EVENT_STOP;
			return result;
		} else {
			if (dy >= ((gdouble) 1)) {
				gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.zoom-out", NULL, NULL);
				result = GDK_EVENT_STOP;
				return result;
			}
		}
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static void
sudoku_window_scroll_begin_cb (SudokuWindow* self,
                               GtkEventControllerScroll* event)
{
	GdkModifierType state = 0U;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	state = gtk_event_controller_get_current_event_state ((GtkEventController*) event);
	if (state == GDK_CONTROL_MASK) {
		gtk_event_controller_scroll_set_flags (event, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL | GTK_EVENT_CONTROLLER_SCROLL_DISCRETE);
	}
}

static void
sudoku_window_scroll_end_cb (SudokuWindow* self,
                             GtkEventControllerScroll* event)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	gtk_event_controller_scroll_set_flags (event, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL);
}

static gdouble
sudoku_window_normalize (SudokuWindow* self,
                         gint val,
                         gint min,
                         gint max)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	CLAMP (val, min, max);
	result = (val - min) / ((gdouble) (max - min));
	return result;
}

static void
sudoku_window_set_gamebox_width_margins (SudokuWindow* self,
                                         gint width)
{
	gdouble factor = 0.0;
	gint margin_size = 0;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	g_return_if_fail (self != NULL);
	factor = sudoku_window_normalize (self, width, SUDOKU_WINDOW_smallest_possible_width, SUDOKU_WINDOW_small_window_width);
	margin_size = SUDOKU_WINDOW_margin_small_size + ((gint) (SUDOKU_WINDOW_margin_size_diff * factor));
	_tmp0_ = self->priv->game_box;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp0_, margin_size);
	_tmp1_ = self->priv->game_box;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp1_, margin_size);
}

static void
sudoku_window_set_gamebox_height_margins (SudokuWindow* self,
                                          gint height)
{
	gdouble factor = 0.0;
	gint margin_size = 0;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	g_return_if_fail (self != NULL);
	factor = sudoku_window_normalize (self, height, self->priv->smallest_possible_height, self->priv->small_window_height);
	margin_size = SUDOKU_WINDOW_margin_small_size + ((gint) (SUDOKU_WINDOW_margin_size_diff * factor));
	_tmp0_ = self->priv->game_box;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp0_, margin_size);
	_tmp1_ = self->priv->game_box;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp1_, margin_size);
}

static void
sudoku_window_real_size_allocate (GtkWidget* base,
                                  gint width,
                                  gint height,
                                  gint baseline)
{
	SudokuWindow * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	self = (SudokuWindow*) base;
	if (width < SUDOKU_WINDOW_small_window_width) {
		_tmp0_ = !self->priv->window_width_is_small;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		sudoku_window_window_width_is_small_cb (self);
	} else {
		gboolean _tmp1_ = FALSE;
		if (width >= SUDOKU_WINDOW_small_window_width) {
			_tmp1_ = self->priv->window_width_is_small;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			sudoku_window_window_width_is_big_cb (self);
		}
	}
	if (self->priv->window_width != width) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = self->priv->window_height != height;
	}
	if (_tmp2_) {
		GtkRequisition min_size = {0};
		GtkRequisition _tmp3_ = {0};
		GtkRequisition _tmp4_;
		GtkRequisition _tmp5_;
		sudoku_window_set_gamebox_width_margins (self, width);
		sudoku_window_set_gamebox_height_margins (self, height);
		gtk_widget_get_preferred_size ((GtkWidget*) self, &_tmp3_, NULL);
		min_size = _tmp3_;
		_tmp4_ = min_size;
		width = MAX (_tmp4_.width, width);
		self->priv->window_width = width;
		_tmp5_ = min_size;
		height = MAX (_tmp5_.height, height);
		self->priv->window_height = height;
	}
	GTK_WIDGET_CLASS (sudoku_window_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_window_get_type (), AdwApplicationWindow), width, height, baseline);
}

static void
sudoku_window_real_dispose (GObject* base)
{
	SudokuWindow * self;
	self = (SudokuWindow*) base;
	gtk_widget_dispose_template ((GtkWidget*) self, G_TYPE_FROM_INSTANCE ((GObject*) self));
	G_OBJECT_CLASS (sudoku_window_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_window_get_type (), AdwApplicationWindow));
}

GSettings*
sudoku_window_get_settings (SudokuWindow* self)
{
	GSettings* result;
	GSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_settings;
	result = _tmp0_;
	return result;
}

static void
sudoku_window_set_settings (SudokuWindow* self,
                            GSettings* value)
{
	GSettings* old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_window_get_settings (self);
	if (old_value != value) {
		GSettings* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_settings);
		self->priv->_settings = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_SETTINGS_PROPERTY]);
	}
}

SudokuView*
sudoku_window_get_view (SudokuWindow* self)
{
	SudokuView* result;
	SudokuView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_view;
	result = _tmp0_;
	return result;
}

static void
sudoku_window_set_view (SudokuWindow* self,
                        SudokuView* value)
{
	SudokuView* old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_window_get_view (self);
	if (old_value != value) {
		SudokuView* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_view);
		self->priv->_view = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_VIEW_PROPERTY]);
	}
}

SudokuWindowScreen
sudoku_window_get_current_screen (SudokuWindow* self)
{
	SudokuWindowScreen result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_current_screen;
	return result;
}

static void
sudoku_window_set_current_screen (SudokuWindow* self,
                                  SudokuWindowScreen value)
{
	SudokuWindowScreen old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_window_get_current_screen (self);
	if (old_value != value) {
		self->priv->_current_screen = value;
		g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY]);
	}
}

gboolean
sudoku_window_get_show_timer (SudokuWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_timer;
	return result;
}

void
sudoku_window_set_show_timer (SudokuWindow* self,
                              gboolean value)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	SudokuWindowScreen _tmp6_;
	g_return_if_fail (self != NULL);
	self->priv->_show_timer = value;
	_tmp1_ = self->priv->game;
	if (_tmp1_ != NULL) {
		SudokuGame* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp2_ = self->priv->game;
		_tmp3_ = sudoku_game_get_paused (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		SudokuGame* _tmp5_;
		_tmp5_ = self->priv->game;
		sudoku_game_set_paused (_tmp5_, FALSE);
	}
	_tmp6_ = self->priv->_current_screen;
	if (_tmp6_ == SUDOKU_WINDOW_SCREEN_PLAY) {
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp7_ = sudoku_window_get_show_timer (self);
		_tmp8_ = _tmp7_;
		if (_tmp8_) {
			GtkToggleButton* _tmp9_;
			GtkBox* _tmp10_;
			_tmp9_ = self->priv->earmark_mode_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp9_, !self->priv->window_width_is_small);
			_tmp10_ = self->priv->clock_box;
			gtk_widget_set_visible ((GtkWidget*) _tmp10_, !self->priv->window_width_is_small);
			sudoku_window_display_pause_button (self);
		} else {
			GtkBox* _tmp11_;
			GtkToggleButton* _tmp12_;
			GtkButton* _tmp13_;
			_tmp11_ = self->priv->clock_box;
			gtk_widget_set_visible ((GtkWidget*) _tmp11_, FALSE);
			_tmp12_ = self->priv->earmark_mode_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp12_, TRUE);
			_tmp13_ = self->priv->play_pause_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
		}
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_SHOW_TIMER_PROPERTY]);
}

static void
sudoku_window_class_init (SudokuWindowClass * klass,
                          gpointer klass_data)
{
	sudoku_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SudokuWindow_private_offset);
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_window_real_size_allocate;
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_window_real_dispose;
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_window_set_property;
	G_OBJECT_CLASS (klass)->finalize = sudoku_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_SETTINGS_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_VIEW_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", TYPE_SUDOKU_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY] = g_param_spec_enum ("current-screen", "current-screen", "current-screen", TYPE_SUDOKU_WINDOW_SCREEN, SUDOKU_WINDOW_SCREEN_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_SHOW_TIMER_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_SHOW_TIMER_PROPERTY] = g_param_spec_boolean ("show-timer", "show-timer", "show-timer", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Sudoku/ui/sudoku-window.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "windowtitle", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, windowtitle));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, headerbar));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "game_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, game_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "start_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, start_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "start_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, start_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, custom_check));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "easy_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, easy_check));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "medium_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, medium_check));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "hard_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, hard_check));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "very_hard_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, very_hard_check));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_menu", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, main_menu));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "earmark_mode_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, earmark_mode_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "undo_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, undo_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "redo_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, redo_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, back_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "unfullscreen_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, unfullscreen_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "play_custom_game_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, play_custom_game_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "play_pause_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, play_pause_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "toggle_fullscreen_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, toggle_fullscreen_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, clock_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_label", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, clock_label));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "start_game_cb", G_CALLBACK(_sudoku_window_start_game_cb_gtk_button_clicked));
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_n, GDK_CONTROL_MASK, "app.new-game", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_p, GDK_CONTROL_MASK, "app.print-current-board", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_p, GDK_NO_MODIFIER_MASK, "app.pause", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_r, GDK_CONTROL_MASK, "app.reset-board", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_u, GDK_NO_MODIFIER_MASK, "app.undo", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_z, GDK_CONTROL_MASK, "app.undo", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_r, GDK_NO_MODIFIER_MASK, "app.redo", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_z, GDK_CONTROL_MASK | GDK_SHIFT_MASK, "app.redo", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_e, GDK_NO_MODIFIER_MASK, "app.earmark-mode", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_question, GDK_CONTROL_MASK, "app.shortcuts-window", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_comma, GDK_CONTROL_MASK, "app.preferences-dialog", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_f, GDK_NO_MODIFIER_MASK, "app.toggle-fullscreen", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_F11, GDK_NO_MODIFIER_MASK, "app.toggle-fullscreen", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_h, GDK_CONTROL_MASK, "app.highlighter", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_w, GDK_CONTROL_MASK, "app.show-warnings", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_0, GDK_CONTROL_MASK, "app.zoom-reset", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_0, GDK_CONTROL_MASK, "app.zoom-reset", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_plus, GDK_CONTROL_MASK, "app.zoom-in", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_equal, GDK_CONTROL_MASK, "app.zoom-in", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Add, GDK_CONTROL_MASK, "app.zoom-in", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_ZoomIn, GDK_NO_MODIFIER_MASK, "app.zoom-in", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_minus, GDK_CONTROL_MASK, "app.zoom-out", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Subtract, GDK_CONTROL_MASK, "app.zoom-out", NULL, NULL);
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_ZoomOut, GDK_NO_MODIFIER_MASK, "app.zoom-out", NULL, NULL);
}

static void
sudoku_window_instance_init (SudokuWindow * self,
                             gpointer klass)
{
	self->priv = sudoku_window_get_instance_private (self);
	self->priv->game = NULL;
	self->priv->_view = NULL;
	self->priv->_current_screen = SUDOKU_WINDOW_SCREEN_NONE;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
sudoku_window_finalize (GObject * obj)
{
	SudokuWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_WINDOW, SudokuWindow);
	_g_object_unref0 (self->priv->game);
	_g_object_unref0 (self->priv->button_controller);
	_g_object_unref0 (self->priv->backwards_controller);
	_g_object_unref0 (self->priv->forwards_controller);
	_g_object_unref0 (self->priv->scroll_controller);
	_g_object_unref0 (self->priv->_settings);
	_g_object_unref0 (self->priv->_view);
	G_OBJECT_CLASS (sudoku_window_parent_class)->finalize (obj);
}

static GType
sudoku_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuWindow), 0, (GInstanceInitFunc) sudoku_window_instance_init, NULL };
	GType sudoku_window_type_id;
	sudoku_window_type_id = g_type_register_static (adw_application_window_get_type (), "SudokuWindow", &g_define_type_info, 0);
	SudokuWindow_private_offset = g_type_add_instance_private (sudoku_window_type_id, sizeof (SudokuWindowPrivate));
	return sudoku_window_type_id;
}

GType
sudoku_window_get_type (void)
{
	static volatile gsize sudoku_window_type_id__once = 0;
	if (g_once_init_enter (&sudoku_window_type_id__once)) {
		GType sudoku_window_type_id;
		sudoku_window_type_id = sudoku_window_get_type_once ();
		g_once_init_leave (&sudoku_window_type_id__once, sudoku_window_type_id);
	}
	return sudoku_window_type_id__once;
}

static void
_vala_sudoku_window_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	SudokuWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_WINDOW, SudokuWindow);
	switch (property_id) {
		case SUDOKU_WINDOW_SETTINGS_PROPERTY:
		g_value_set_object (value, sudoku_window_get_settings (self));
		break;
		case SUDOKU_WINDOW_VIEW_PROPERTY:
		g_value_set_object (value, sudoku_window_get_view (self));
		break;
		case SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY:
		g_value_set_enum (value, sudoku_window_get_current_screen (self));
		break;
		case SUDOKU_WINDOW_SHOW_TIMER_PROPERTY:
		g_value_set_boolean (value, sudoku_window_get_show_timer (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sudoku_window_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	SudokuWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_WINDOW, SudokuWindow);
	switch (property_id) {
		case SUDOKU_WINDOW_SETTINGS_PROPERTY:
		sudoku_window_set_settings (self, g_value_get_object (value));
		break;
		case SUDOKU_WINDOW_VIEW_PROPERTY:
		sudoku_window_set_view (self, g_value_get_object (value));
		break;
		case SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY:
		sudoku_window_set_current_screen (self, g_value_get_enum (value));
		break;
		case SUDOKU_WINDOW_SHOW_TIMER_PROPERTY:
		sudoku_window_set_show_timer (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static GType
sudoku_window_screen_get_type_once (void)
{
	static const GEnumValue values[] = {{SUDOKU_WINDOW_SCREEN_NONE, "SUDOKU_WINDOW_SCREEN_NONE", "none"}, {SUDOKU_WINDOW_SCREEN_PLAY, "SUDOKU_WINDOW_SCREEN_PLAY", "play"}, {SUDOKU_WINDOW_SCREEN_CREATE, "SUDOKU_WINDOW_SCREEN_CREATE", "create"}, {SUDOKU_WINDOW_SCREEN_MENU, "SUDOKU_WINDOW_SCREEN_MENU", "menu"}, {0, NULL, NULL}};
	GType sudoku_window_screen_type_id;
	sudoku_window_screen_type_id = g_enum_register_static ("SudokuWindowScreen", values);
	return sudoku_window_screen_type_id;
}

GType
sudoku_window_screen_get_type (void)
{
	static volatile gsize sudoku_window_screen_type_id__once = 0;
	if (g_once_init_enter (&sudoku_window_screen_type_id__once)) {
		GType sudoku_window_screen_type_id;
		sudoku_window_screen_type_id = sudoku_window_screen_get_type_once ();
		g_once_init_leave (&sudoku_window_screen_type_id__once, sudoku_window_screen_type_id);
	}
	return sudoku_window_screen_type_id__once;
}

